#!/usr/bin/env sh

IMAGE=node:23-alpine3.20

docker run --rm \
    -v $(pwd):/app \
    -w /app \
    -u $(id -u):$(id -g) \
    $IMAGE \
    yarn && yarn build

if [ $? -ne 0 ]; then
    echo "Error while building frontend app"
    exit 1
fi

echo "Build successfully in $(pwd)/dist"
